         TITLE 'FINDTEXT - TEXT SEARCH UTILITY - WRITTEN BY ARIE VAN WIX00001000
               NGERDEN ON 05/02/1988'                                   00002000
         PRINT GEN                                                      00003000
         REGEQU                                                         00004000
*--------------------------------------------------------------------*  00005000
*        THE NEXT VALUES CAN BE MODIFIED                             *  00006000
*--------------------------------------------------------------------*  00007000
IRL      EQU   139        SRCHFILE RECORDLENGTH                         00008000
IKL      EQU   6          SRCHFILE KEYLENGTH (KEYS AT BEGIN OF RECORD)  00009000
ORL      EQU   4096       MAXIMUM OUTPUT RECORD LENGTH (VARIABLE)       00010000
*                         NOTE : THE FIELD 'OMK' CONTAINS THE MAXIMUM   00011000
*                                NUMBER OF KEYS WITH LENGTH 'IKL'       00012000
*                                WHICH WILL FIT IN ONE OUTPUT RECORD    00013000
*--------------------------------------------------------------------*  00014000
*        START OF PROGRAM                                            *  00015000
*--------------------------------------------------------------------*  00016000
FINDTEXT CSECT                                                          00017000
*--------------------------------------------------------------------*  00018000
*        OBEY LINKAGE CONVENTIONS                                    *  00019000
*--------------------------------------------------------------------*  00020000
MAIN$000 EQU   *                                                        00021000
         STM   R14,R12,12(R13)       SAVE CALLERS ENVIRONMENT           00022000
         LR    R12,R15               GET PGM START ADDRESS              00023000
         USING FINDTEXT,R12          R12 IS BASE REGISTER               00024000
         USING SRCHTAB,R10           R10 USED FOR SRCHTAB DSECT         00025000
         LR    R2,R13                KEEP CALLERS SAVE AREA ADDRESS     00026000
         LA    R13,SAVEAREA          GET OUR SAVE AREA ADDRESS          00027000
         ST    R13,8(,R2)            STORE FORWARD POINTER              00028000
         ST    R2,4(,R13)            STORE BACKWARD POINTER             00029000
*--------------------------------------------------------------------*  00030000
*        SHORT PROGRAM DESCRIPTION                                   *  00031000
*--------------------------------------------------------------------*  00032000
* FINDTEXT EXPECTS A TOKENIXED PLIST, CONTAINING THE PARAMETERS :    *  00033000
*    1. THE FILEID (FN, FT AND FM) OF THE FILE TO BE SEARCHED IN;    *  00034000
*       - THIS FILE SHOULD BE PRESENT (IF NOT ==> ERROR)             *  00035000
*       - THE KEYLENGTH USED FOR THIS FILE IS ALWAYS 'IKL'           *  00036000
*       - THE KEY POSITIONS ARE FROM COLUMN 1 TO COLUMN 'IKL'        *  00037000
*       - THE RECORDFORMAT OF THIS FILE MAY BE FIXED OR VARIABLE     *  00038000
*       - THE MAXIMUM RECORDLENGTH OF THIS FILE SHOULD BE 'IRL'      *  00039000
*    2. THE FILEID (FN, FT AND FM) OF A WORKFILE, WHICH WILL CONTAIN *  00040000
*       ALL THE KEYS FOUND DURING A SEARCH OPERATION;                *  00041000
*       - THIS FILE WILL BE ERASED, IF IT EXISTS, BY THIS PROGRAM    *  00042000
*              BEFORE ANY OUTPUT RECORD WILL BE WRITTEN TO IT        *  00043000
*       - THE RECORDFORMAT OF THIS FILE WILL BE VARIABLE             *  00044000
*       - THE MAXIMUM RECORDLENGTH MUST BE <= 'ORL' AND CONSISTS OF  *  00045000
*         THE NUMBER SPECIFIED BY PARAMETER-3 * THE KEYLENGTH        *  00046000
*         ('IKL'); MAXIMUM VALUE FOR THE RECORDLENGTH IS A MULTIPLE  *  00047000
*         OF 'IKL'; THIS MAXIMUM CAN BE FOUND IN FIELD 'OMK'         *  00048000
*    3. THE NUMBER OF KEYS TO BE STORED IN ONE WORKFILE RECORD;      *  00049000
*       - THIS NUMBER SHOULD BE A 3 DIGIT NUMBER BETWEEN 1 AND 'OMK' *  00050000
*       - THIS NUMBER SHOULD HAVE LEADING ZEROES, SUCH THAT FOR      *  00051000
*              EXAMPLE 2 SHOULD BE SPECIFIED AS 002;                 *  00052000
*--------------------------------------------------------------------*  00053000
* THE CALL FORMAT SHOULD BE :                                        *  00054000
*     FINDTEXT <FILEID1> <FILEID2> <NNN>                             *  00055000
* NOTE : NEVER USE 'RUN' OR 'LOAD' OR 'START'                        *  00056000
*--------------------------------------------------------------------*  00057000
* FINDTEXT EXPECTS ONE ORE MORE ITEMS IN THE STACK :                 *  00058000
*    - EVERY ITEM IN THE STACK SHOULD CONSIST OF 1 OR MORE STRINGS   *  00059000
*    - ITEMS ARE DELIMITED BY X'EE'                                  *  00060000
*    - STRINGS MAY BE PRECEEDED BY THE \ (NOT) character             *  00061000
*--------------------------------------------------------------------*  00062000
* FINDTEXT HANDLES ERRORS AS FOLLOWS :                               *  00063000
*    IF AN ERROR IS ENCOUNTERED, NORMAL PROCESSING WILL BE STOPPED   *  00064000
*    AND THE PROGRAM WILL RETURN TO THE CALLER WITH A RETURNCODE     *  00065000
*    INDICATING THE ERROR TO THE CALLER.                             *  00066000
*--------------------------------------------------------------------*  00067000
* PROCESSING :                                                       *  00068000
*    1. ALL STACK ENTRIES WILL BE READ                               *  00069000
*    2. INDIVIDUAL STRINGS OF AN ENTRY WILL BE PLACED IN 1 WORD-LIST *  00070000
*       AND MAY HAVE A \ (NOT) INDICATION                            *  00071000
*    3. IT IS ALSO POSSIBLE TO HAVE THE FOLLOWING FORM OF STRING :   *  00072000
*       <WORD><CMP><VALUE>, WHERE :                                  *  00073000
*       - <WORD>  IS A STRING TO BE FOUND IN THE RECORD              *  00074000
*       - <CMP>   CAN BE < (LESS THAN) OR > (GREATER THAN)           *  00075000
*       - <VALUE> IS THE VALUE TO COMPARE THE PART OF THE RECORD     *  00076000
*                 DIRECTLY AFTER <WORD> WITH; THE LENGTH TO BE       *  00077000
*                 COMPARED IS EQUAL TO THE LENGTH OF <VALUE>;        *  00078000
*                 COMPARE WILL BE DONE ALPHANUMERICALLY              *  00079000
*    4. <FILEID1> WILL BE READ                                       *  00080000
*    5. POSITION 1 TO 'IKL' OF THE INPUT RECORD IS THE KEY;          *  00081000
*       WHEN A CHANGE OF KEY IS DETECTED, GO TO STEP 8               *  00082000
*    6. SEARCH IN THE RECORD (BEYOND POSITION 'IKL') FOR ALL STRINGS *  00083000
*       FOUND IN ALL STACK ENTRIES (THIS WILL BE IGNORED, IF ALREADY *  00084000
*       ALL STRINGS HAVE BEEN FOUND)                                 *  00085000
*       NOTE : IN THE CASE OF COMPARE (SEE 3) THE COMPARE WILL BE    *  00086000
*              DONE; A STRING WILL THEN BE MARKED AS FOUND WHEN THE  *  00087000
*              COMPARISON SUCCEEDS                                   *  00088000
*    7. EVERY STRING FOUND WILL BE MARKED AS SUCH                    *  00089000
*       NOTE : DURING THE SEARCH OPERATIONS, COMPARISON IS DONE ON A *  00090000
*              MIXED CASE BASIS (IN FACT BOTH THE RECORD TO BE       *  00091000
*              SEARCHED IN AND THE SEARCH ARGUMENTS WILL BE          *  00092000
*              TRANSLATED TO UPPERCASE BY THIS PROGRAM, BEFORE       *  00093000
*              BEFORE COMPARISON STARTS)                             *  00094000
*    8. GO TO STEP 3                                                 *  00095000
*    9. ALL STRING-LISTS (EACH AS A RESULT OF ONE STACK-ENTRY) WILL  *  00096000
*       BE CHECKED                                                   *  00097000
*   10. IF ALL STRINGS IN 1 OF THE LISTS WERE FOUND (OR NOT FOUND    *  00098000
*       WHEN THEY HAD A \ (NOT) INDICATION !) THE VALUE OF THE KEY   *  00099000
*       ASSOCIATED WITH THEM WILL BE WRITTEN IN THE BUFFER OF THE    *  00100000
*       WORKFILE; THE WORKFILE RECORD WILL BE WRITTEN IF A RECORD    *  00101000
*       IS FULL AND AT THE END OF THE PROGRAM (LAST RECORD);         *  00102000
*       A RECORD IS FULL WHEN THE NUMBER OF KEYS SPECIFIED BY THE    *  00103000
*       3RD PARAMETER HAS BEEN WRITTEN IN THE OUTPUT BUFFER)         *  00104000
*--------------------------------------------------------------------*  00105000
         MVC   SRCHFILE+8(18),8(R1)  MOVE FILEID TO FSCB SRCHFILE       00106000
         MVC   FINDFILE+8(18),32(R1) MOVE FILEID TO FSCB FINDFILE       00107000
         CLI   56(R1),X'F0'          CHECK IF FIELD NUMERIC             00108000
         BL    MAIN$005              ERROR                              00109000
         CLI   56(R1),X'F9'          CHECK IF FIELD NUMERIC             00110000
         BH    MAIN$005              ERROR                              00111000
         CLI   57(R1),X'F0'          CHECK IF FIELD NUMERIC             00112000
         BL    MAIN$005              ERROR                              00113000
         CLI   57(R1),X'F9'          CHECK IF FIELD NUMERIC             00114000
         BH    MAIN$005              ERROR                              00115000
         CLI   58(R1),X'F0'          CHECK IF FIELD NUMERIC             00116000
         BL    MAIN$005              ERROR                              00117000
         CLI   58(R1),X'F9'          CHECK IF FIELD NUMERIC             00118000
         BH    MAIN$005              ERROR                              00119000
         CLC   59(5,R1),BLANK005     CHECK REST OF TOKEN                00120000
         BE    MAIN$008              IF BLANK, THEN OKAY                00121000
MAIN$005 EQU   *                                                        00122000
******** FINDTEXT RC 2  : WRONG NR. OF KEYS : < 001 | > 'OMK'           00123000
         LA    R15,2                                                    00124000
         B     MAIN$999                                                 00125000
MAIN$008 EQU   *                                                        00126000
         PACK  PRECKEYS(8),56(3,R1)  PACK MAX. NR. OF KEYS              00127000
         CVB   R11,PRECKEYS          CONVERT TO BINARY                  00128000
         STH   R11,RECKEYS           STORE VALUE FOR LATER USE          00129000
         CH    R11,OMK               CHECK VALUE                        00130000
         BNH   MAIN$010                                                 00131000
******** FINDTEXT RC 3  : NR. OF KEYS > 'OMK'                           00132000
         LA    R15,3                                                    00133000
         B     MAIN$999                                                 00134000
MAIN$010 EQU   *                                                        00135000
         CH    R11,=H'0'             CHECK VALUE                        00136000
         BH    MAIN$015                                                 00137000
******** FINDTEXT RC 4  : NR. OF KEYS < 1                               00138000
         LA    R15,4                                                    00139000
         B     MAIN$999                                                 00140000
MAIN$015 EQU   *                                                        00141000
         FSERASE FSCB=FINDFILE       ERASE THE OUTPUT FILE              00142000
         LTR   R15,R15               TEST RETURNCODE                    00143000
         BZ    MAIN$020               0 IS OKAY                         00144000
         CH    R15,=H'28'                                               00145000
         BE    MAIN$020              28 IS OKAY                         00146000
******** FINDTEXT RC 5  : FSERASE RC < 0 | 28                           00147000
         LA    R15,5                                                    00148000
         B     MAIN$999                                                 00149000
MAIN$020 EQU   *                                                        00150000
*--------------------------------------------------------------------*  00151000
*        GET 256 BYTES STORAGE FOR STACK INPUT                       *  00152000
*--------------------------------------------------------------------*  00153000
         DMSFREE DWORDS=32,AREA=HIGH,TYPE=USER,TYPCALL=SVC              00154000
         LTR   R15,R15                                                  00155000
         BZ    MAIN$025                                                 00156000
******** FINDTEXT RC 6  : DMSFREE RC <> 0                               00157000
         LA    R15,6                                                    00158000
         B     MAIN$999                                                 00159000
MAIN$025 EQU   *                                                        00160000
         STCM  R1,7,STCKBUF          STORE ADDRESS (3 BYTES)            00161000
*--------------------------------------------------------------------*  00162000
*        GET 2K STORAGE FOR SEARCHLIST TABLE                         *  00163000
*--------------------------------------------------------------------*  00164000
         DMSFREE DWORDS=256,AREA=HIGH,TYPE=USER,TYPCALL=SVC             00165000
         LTR   R15,R15                                                  00166000
         BZ    MAIN$030                                                 00167000
******** FINDTEXT RC 7  : DMSFREE RC <> 0                               00168000
         LA    R15,7                                                    00169000
         B     MAIN$999                                                 00170000
MAIN$030 EQU   *                                                        00171000
         ST    R1,SRCHLBUF           STORE ADDRESS                      00172000
*--------------------------------------------------------------------*  00173000
*        GET 2K STORAGE FOR COMPARE-VALUE TABLE                      *  00174000
*--------------------------------------------------------------------*  00175000
         DMSFREE DWORDS=256,AREA=HIGH,TYPE=USER,TYPCALL=SVC             00176000
         LTR   R15,R15                                                  00177000
         BZ    MAIN$035                                                 00178000
******** FINDTEXT RC 8  : DMSFREE RC <> 0                               00179000
         LA    R15,8                                                    00180000
         B     MAIN$999                                                 00181000
MAIN$035 EQU   *                                                        00182000
         ST    R1,VALBUF             STORE ADDRESS                      00183000
         ST    R1,CVALBUF            WORK AREA                          00184000
*--------------------------------------------------------------------*  00185000
*        GET 256 BYTES STORAGE FOR RECORDBUFFER OF SRCHFILE          *  00186000
*            NOTE : RECORD LENGTH IS 'IRL';                          *  00187000
*                   256 BYTES NEEDED TO AVOID PROBLEMS WHEN          *  00188000
*                   COMPARING VALUES BEYOND THE END OF THE RECORD    *  00189000
*--------------------------------------------------------------------*  00190000
         DMSFREE DWORDS=32,AREA=HIGH,TYPE=USER,TYPCALL=SVC              00191000
         LTR   R15,R15                                                  00192000
         BZ    MAIN$040                                                 00193000
******** FINDTEXT RC 9  : DMSFREE RC <> 0                               00194000
         LA    R15,9                                                    00195000
         B     MAIN$999                                                 00196000
MAIN$040 EQU   *                                                        00197000
         ST    R1,SRCHBUF            STORE ADDRESS                      00198000
         MVI   0(R1),X'40'           CLEAR BUFFER TO BLANKS             00199000
         MVC   1(255,R1),0(R1)                                          00200000
*--------------------------------------------------------------------*  00201000
*        GET 4K STORAGE FOR RECORDBUFFER OF FINDFILE                 *  00202000
*--------------------------------------------------------------------*  00203000
         DMSFREE DWORDS=512,AREA=HIGH,TYPE=USER,TYPCALL=SVC             00204000
         LTR   R15,R15                                                  00205000
         BZ    MAIN$045                                                 00206000
******** FINDTEXT RC 10 : DMSFREE RC <> 0                               00207000
         LA    R15,10                                                   00208000
         B     MAIN$999                                                 00209000
MAIN$045 EQU   *                                                        00210000
         ST    R1,FINDBUF            STORE ADDRESS                      00211000
*--------------------------------------------------------------------*  00212000
*        ASK CMS HOW MANY LINES ARE STACKED CURRENTLY                *  00213000
*        NOTE : SENTRIES RETURNS THE NUMBER OF LINES IN THE STACK    *  00214000
*               IN R15; HOWEVER, IF R15 IS NOT ZERO, A JUMP WILL BE  *  00215000
*               MADE TO THE ERROR ROUTINE; IN OUR CASE A BRANCH      *  00216000
*               WILL OCCUR TO MAIN$100 WHENEVER THERE ARE MORE THAN  *  00217000
*               ZERO LINES IN THE STACK; IF NO LINES IN THE STACK,   *  00218000
*               R15 WILL BE ZERO, NO BRANCH TO THE ERROR ROUTINE     *  00219000
*               WILL OCCUR, BUT THE PROGRAM WILL EXECUTE THE NEXT    *  00220000
*               SEQUENTIAL INSTRUCTION, WHICH IS AT MAIN$100 AS WELL *  00221000
*--------------------------------------------------------------------*  00222000
         LA    R1,SENTRIES           EXECUTE THE SENTRIES COMMAND       00223000
         SVC   202                   USING SVC 202                      00224000
         DC    AL4(MAIN$100)         CHECK NUMBER OF ENTRIES            00225000
MAIN$100 EQU   *                                                        00226000
*--------------------------------------------------------------------*  00227000
*        BUILD SEARCH TABLE FROM THE STRINGS IN THE LISTS FOUND      *  00228000
*        IN THE STACK                                                *  00229000
*--------------------------------------------------------------------*  00230000
         LTR   R2,R15                NUMBER OF ENTRIES IN THE STACK     00231000
         BNZ   MAIN$105              IF NOT ZERO ===> SKIP              00232000
******** FINDTEXT RC 11 : STACK IS EMPTY                                00233000
         LA    R15,11                                                   00234000
         B     MAIN$999                                                 00235000
MAIN$105 EQU   *                                                        00236000
         XR    R4,R4                 CLEAR R4                           00237000
         ICM   R4,7,STCKBUF          LOAD ADDRESS OF STACK BUFFER       00238000
         L     R10,SRCHLBUF          LOAD ADDRESS OF SEARCH BUFFER      00239000
         MVI   SRCHLIST,X'00'        INDICATE END OF TABLE (LIST = 0)   00240000
         LA    R6,0                  LIST NUMBER                        00241000
         LA    R3,0                  TOTAL NUMBER OF STRINGS IN LISTS   00242000
MAIN$200 EQU   *                                                        00243000
         LA    R6,1(,R6)             NEXT LIST NUMBER                   00244000
*        *-----------------------------------------------------------*  00245000
*        * READ A RECORD FROM THE STACK                              *  00246000
*        *-----------------------------------------------------------*  00247000
         MVC   STCKLEN(2),STCKBUFL   RESET INPUT LENGTH                 00248000
         MVI   0(R4),X'40'           STACK BUFFER := BLANK              00249000
         MVC   1(255,R4),0(R4)                                          00250000
         LA    R1,WAITRD             EXECUTE CMS WAITRD FUNCTION        00251000
         SVC   202                   USING SVC 202                      00252000
         DC    AL4(1)                NO ERROR HANDLING                  00253000
         LTR   R15,R15                                                  00254000
         BZ    MAIN$205                                                 00255000
******** FINDTEXT RC 12 : WAITRD RC <> 0                                00256000
         LA    R15,12                                                   00257000
         B     MAIN$999                                                 00258000
MAIN$205 EQU   *                                                        00259000
         CLI   0(R4),X'40'           FIRST BYTE BLANK ?                 00260000
         BNE   MAIN$210              NO; SKIP                           00261000
         CLC   1(255,R4),0(R4)       REST BLANK ?                       00262000
         BNE   MAIN$210              NO; SKIP                           00263000
******** FINDTEXT RC 13 : STACK ENTRY IS BLANK                          00264000
         LA    R15,13                                                   00265000
         B     MAIN$999                                                 00266000
MAIN$210 EQU   *                                                        00267000
         TR    0(256,R4),TRANTAB     TRANSLATE TO UPPERCASE             00268000
*        *-----------------------------------------------------------*  00269000
*        * FIND STRINGS IN LIST IN CURRENT STACK BUFFER              *  00270000
*        *-----------------------------------------------------------*  00271000
         LH    R9,STCKLEN            NUMBER OF BYTES IN BUFFER          00272000
         LR    R8,R4                 POINT TO STACK BUFFER              00273000
         MVI   SWNOT,X'40'           RESET SWNOT FOR NEXT STRING        00274000
         MVI   SWCMP,X'40'           RESET SWCMP FOR NEXT STRING        00275000
MAIN$220 EQU   *                                                        00276000
         CLI   0(R8),C'\'            CURRENT CHARACTER '\' ?            00277000
         BNE   MAIN$230              IF NOT ==> BRANCH                  00278000
         MVI   SWNOT,C'\'            MOVE INDICATION \ TO SWITCH        00279000
         B     MAIN$235              AND SKIP CHARACTER \ ITSELF        00280000
MAIN$230 EQU   *                                                        00281000
         CLI   0(R8),X'EE'           CURRENT CHARACTER = DELIMITER?     00282000
         BNE   MAIN$240              IF NOT ==> BRANCH                  00283000
MAIN$235 EQU   *                                                        00284000
         LA    R8,1(,R8)             POINT TO NEXT BYTE IN BUFFER       00285000
         BCT   R9,MAIN$220           CHECK END OF BUFFER                00286000
         B     MAIN$290              IF END OF BUFFER, GO OUTER LOOP    00287000
MAIN$240 EQU   *                                                        00288000
         LA    R7,0                  LENGTH OF STRING                   00289000
         LA    R5,SRCHWORD           POINT R5 TO STRING CONTENTS        00290000
MAIN$260 EQU   *                                                        00291000
         CLI   0(R8),X'EE'           CHECK END OF STRING                00292000
         BE    MAIN$280                                                 00293000
         CLI   0(R8),C'<'            CHECK COMPARE REQUEST              00294000
         BE    MAIN$270                                                 00295000
         CLI   0(R8),C'>'            CHECK COMPARE REQUEST              00296000
         BE    MAIN$270                                                 00297000
         MVC   0(1,R5),0(R8)         MOVE 1 BYTE                        00298000
         LA    R8,1(,R8)             POINT TO NEXT BYTE IN BUFFER       00299000
         LA    R5,1(,R5)             POINT TO NEXT BYTE OF STRING       00300000
         LA    R7,1(,R7)             ADD 1 TO STRINGLENGTH              00301000
         BCT   R9,MAIN$260                                              00302000
         B     MAIN$280                                                 00303000
MAIN$270 EQU   *                                                        00304000
         MVC   SWCMP(1),0(R8)        SET SWCMP                          00305000
         LA    R8,1(,R8)             POINT TO NEXT BYTE IN STACKBUFFER  00306000
         BCTR  R9,0                                                     00307000
         LA    R14,0                 LENGTH OF VALUE                    00308000
         L     R5,CVALBUF            POINT R5 TO VALUE CONTENTS         00309000
MAIN$275 EQU   *                                                        00310000
         CLI   0(R8),X'EE'           CHECK END OF VALUE                 00311000
         BE    MAIN$280                                                 00312000
         MVC   0(1,R5),0(R8)         MOVE 1 BYTE                        00313000
         LA    R8,1(,R8)             POINT TO NEXT BYTE IN BUFFER       00314000
         LA    R5,1(,R5)             POINT TO NEXT BYTE OF STRING       00315000
         LA    R14,1(,R14)           ADD 1 TO LENGTH OF VALUE           00316000
         BCT   R9,MAIN$275                                              00317000
MAIN$280 EQU   *                                                        00318000
         MVC   SRCHVCMP(1),SWCMP     STORE INDICATION > OR <            00319000
         CLI   SWCMP,X'40'           IF BLANK ...                       00320000
         BE    MAIN$285                 SKIP VALUE SETTINGS             00321000
         MVI   SWCMP,X'40'           RESET SWCMP FOR NEXT VALUE         00322000
         STC   R14,SRCHVLEN          STORE LENGTH OF VALUE              00323000
         MVC   SRCHVADD(3),CVALBUF+1 MOVE ADDRESS OF VALUE              00324000
         L     R5,CVALBUF            SET ADDRESS FOR NEXT VALUE         00325000
         AR    R5,R14                                                   00326000
         ST    R5,CVALBUF                                               00327000
MAIN$285 EQU   *                                                        00328000
         STC   R6,SRCHLIST           STORE LISTNUMBER                   00329000
         MVI   SRCHFND,C'N'          STORE INDICATION "NOT FOUND"       00330000
         MVC   SRCHNOT(1),SWNOT      STORE INDICATION "NOT" (\)         00331000
         MVI   SWNOT,X'40'           RESET SWNOT FOR NEXT STRING        00332000
         STC   R7,SRCHWLEN           STORE STRINGLENGTH                 00333000
         LA    R3,1(,R3)             ADD 1 TO TOTAL # STRINGS IN LISTS  00334000
         LA    R10,STL(,R10)         NEXT SRCHTAB ENTRY                 00335000
         AR    R10,R7                                                   00336000
         MVI   0(R10),X'00'          INDICATE END OF TABLE (LIST = 0)   00337000
*        *-----------------------------------------------------------*  00338000
*        * GO, SEARCH NEXT STRING IN STACK BUFFER                    *  00339000
*        *-----------------------------------------------------------*  00340000
         LTR   R9,R9                 END OF BUFFER ALREADY REACHED ?    00341000
         BNZ   MAIN$220              NO, CONTINUE SEARCH                00342000
*        *-----------------------------------------------------------*  00343000
*        * END OF LOOP (MAIN$200)                                    *  00344000
*        *-----------------------------------------------------------*  00345000
MAIN$290 EQU   *                                                        00346000
         BCT   R2,MAIN$200           LOOP FOR NEXT STACK ENTRY          00347000
         STH   R3,WCOUNT             STORE TOTAL # STRINGS IN LISTS     00348000
         EJECT                                                          00349000
*--------------------------------------------------------------------*  00350000
*        READ THE SRCHFILE AND PUT THE KEYS OFF ALL THE SELECTED     *  00351000
*        RECORDS IN THE STACK                                        *  00352000
*--------------------------------------------------------------------*  00353000
*        *-----------------------------------------------------------*  00354000
*        * OPEN THE FINDFILE FOR OUTPUT                              *  00355000
*        *      INITIALIZE POINTER TO FINDBUF                        *  00356000
*        *      SET KEY COUNTER TO ZERO                              *  00357000
*        *-----------------------------------------------------------*  00358000
         FSOPEN FSCB=FINDFILE,FORM=E                                    00359000
         LTR   R15,R15               TEST RETURNCODE                    00360000
         BZ    MAIN$292               0 IS OKAY                         00361000
         CH    R15,=H'28'                                               00362000
         BE    MAIN$292              28 IS OKAY                         00363000
******** FINDTEXT RC 14 : FSOPEN RC <> 0 | 28                           00364000
         LA    R15,14                                                   00365000
         B     MAIN$999                                                 00366000
MAIN$292 EQU   *                                                        00367000
         MVC   CFINDBUF(4),FINDBUF   POINT TO RECORD BUFFER             00368000
         LA    R11,0                 RESET KEY COUNTER                  00369000
*        *-----------------------------------------------------------*  00370000
*        * OPEN THE SRCHFILE FOR INPUT                               *  00371000
*        * NOTE : THE FSPOINT IS NEEDED, BECAUSE THE OPEN WILL NOT   *  00372000
*        *        RESET THE READ POINTER IF THE FILE WAS ALREADY     *  00373000
*        *        OPEN AT THE TIME WE DID OUR 'OPEN'                 *  00374000
*        *-----------------------------------------------------------*  00375000
         FSOPEN FSCB=SRCHFILE,FORM=E                                    00376000
         LTR   R15,R15               TEST RETURNCODE                    00377000
         BZ    MAIN$294               0 IS OKAY                         00378000
******** FINDTEXT RC 15 : FSOPEN RC <> 0                                00379000
         LA    R15,15                                                   00380000
         B     MAIN$999                                                 00381000
MAIN$294 EQU   *                                                        00382000
         FSPOINT FSCB=SRCHFILE,RDPNT=1,FORM=E                           00383000
         LTR   R15,R15               TEST RETURNCODE                    00384000
         BZ    MAIN$296               0 IS OKAY                         00385000
******** FINDTEXT RC 16 : FSPOINT RC <> 0                               00386000
         LA    R15,16                                                   00387000
         B     MAIN$999                                                 00388000
MAIN$296 EQU   *                                                        00389000
*        *-----------------------------------------------------------*  00390000
*        * READ A RECORD FROM THE SRCHFILE                           *  00391000
*        *-----------------------------------------------------------*  00392000
MAIN$300 EQU   *                                                        00393000
         FSREAD FSCB=SRCHFILE,FORM=E,RECNO=0                            00394000
         LTR   R15,R15               TEST RETURNCODE                    00395000
         BZ    MAIN$301               0 IS OKAY                         00396000
         CH    R15,=H'12'                                               00397000
         BE    MAIN$800              12 IS OKAY (END OF FILE)           00398000
******** FINDTEXT RC 17 : FSREAD RC <> 0 | 12                           00399000
         LA    R15,17                                                   00400000
         B     MAIN$999                                                 00401000
MAIN$301 EQU   *                                                        00402000
         CH    R0,RECLEN             CHECK RECORD LENGTH                00403000
         BNH   MAIN$302                                                 00404000
******** FINDTEXT RC 18 : RECSIZE > 'IRL'                               00405000
         LA    R15,18                                                   00406000
         B     MAIN$999                                                 00407000
MAIN$302 EQU   *                                                        00408000
         CH    R0,KEYLEN             CHECK RECORD LENGTH                00409000
         BNL   MAIN$303                                                 00410000
******** FINDTEXT RC 19 : RECSIZE < 'IKL'                               00411000
         LA    R15,19                                                   00412000
         B     MAIN$999                                                 00413000
MAIN$303 EQU   *                                                        00414000
         SH    R0,KEYLEN             SUBTRACT KEYLENGTH FROM LRECL      00415000
         STH   R0,LRECL              STORE RECORD LENGTH MINUS KEY      00416000
         L     R15,SRCHBUF           LOAD RECORD ADDRESS                00417000
         TR    0(IRL,R15),TRANTAB    TRANSLATE RECORD TO UPPERCASE      00418000
*        *-----------------------------------------------------------*  00419000
*        * CHECK KEY CHANGE                                          *  00420000
*        *-----------------------------------------------------------*  00421000
         MVC   KEY(IKL),0(R15)       MOVE NEW KEY                       00422000
         CLI   FIRSTIME,C'Y'         IS IT THE FIRST TIME THROUGH ?     00423000
         BNE   MAIN$305              NO, BRANCH                         00424000
         MVC   KEYOLD(IKL),KEY       YES, MOVE KEY TO KEYOLD            00425000
         MVC   COUNT(2),=H'0'        STRINGCOUNTER := ZERO              00426000
         MVI   FIRSTIME,C'N'         NOW IT'S NO MORE THE FIRST TIME    00427000
MAIN$305 EQU   *                                                        00428000
         CLC   KEY(IKL),KEYOLD       COMPARE THE KEYS                   00429000
         BE    MAIN$400              EQUAL KEYS                         00430000
*        *-----------------------------------------------------------*  00431000
*        * KEYS ARE NOT EQUAL; CHECK WHETHER SEARCH WAS SUCCESSFULL  *  00432000
*        *-----------------------------------------------------------*  00433000
MAIN$307 EQU   *                                                        00434000
         L     R10,SRCHLBUF          LOAD ADDRESS OF SEARCH BUFFER      00435000
         MVI   LISTIND,C'Y'          LIST INDICATOR                     00436000
         MVC   OLDLIST(1),SRCHLIST   INITIAL OLD LIST NUMBER            00437000
MAIN$310 EQU   *                                                        00438000
         CLC   SRCHLIST(1),OLDLIST   SAME LISTNUMBER                    00439000
         BE    MAIN$320              YES, BRANCH                        00440000
         CLI   LISTIND,C'Y'          ALL STRINGS IN LIST DO MATCH ?     00441000
         BE    MAIN$315              YES, BRANCH                        00442000
*        *-----------------------------------------------------------*  00443000
*        * CHECK NEXT LIST IN SRCHTAB                                *  00444000
*        *-----------------------------------------------------------*  00445000
         CLI   SRCHLIST,X'00'        END OF SEARCH TABLE FOUND ?        00446000
         BE    MAIN$380              YES, BRANCH                        00447000
         MVI   LISTIND,C'Y'          LIST INDICATOR                     00448000
         MVC   OLDLIST(1),SRCHLIST   MOVE LIST NUMBER                   00449000
         B     MAIN$320                                                 00450000
*        *-----------------------------------------------------------*  00451000
*        * SUCCESSFULL MATCH; STORE THE KEY IN FINDFILE              *  00452000
*        *-----------------------------------------------------------*  00453000
MAIN$315 EQU   *                                                        00454000
         CLC   KEYOLD(IKL),KEYBLANK  IS THE KEY BLANK ?                 00455000
         BE    MAIN$380              YES, SKIP DELETED RECORD KEY       00456000
         CH    R11,RECKEYS           NUMBER OF KEYS REACHED ?           00457000
         BL    MAIN$317              NOT YET; SKIP OUTPUT               00458000
         MH    R11,KEYLEN            CALCULATE ACTUAL RECORD LENGTH     00459000
         ST    R11,FINDWLEN                                             00460000
         FSWRITE FSCB=FINDFILE,FORM=E,RECNO=0                           00461000
         LTR   R15,R15               TEST RETURNCODE                    00462000
         BZ    MAIN$316               0 IS OKAY                         00463000
******** FINDTEXT RC 20 : FSWRITE RC <> 0                               00464000
         LA    R15,20                                                   00465000
         B     MAIN$999                                                 00466000
MAIN$316 EQU   *                                                        00467000
         MVI   SWWRITE,C'Y'          INDICATE RECORD HAS BEEN WRITTEN   00468000
         MVC   CFINDBUF(4),FINDBUF   POINT TO RECORD BUFFER             00469000
         LA    R11,0                 RESET KEY COUNTER                  00470000
MAIN$317 EQU   *                                                        00471000
         L     R1,CFINDBUF           ADDRESS OF KEY IN FINDBUF          00472000
         MVC   0(IKL,R1),KEYOLD      MOVE THE KEY                       00473000
         LA    R1,IKL(,R1)           POINT BEYOND THE KEY               00474000
         ST    R1,CFINDBUF           STORE NEW ADDRESS                  00475000
         LA    R11,1(,R11)           ADD 1 TO KEY-COUNTER               00476000
         B     MAIN$380                                                 00477000
MAIN$320 EQU   *                                                        00478000
         CLI   SRCHFND,C'Y'          THIS STRING FOUND ?                00479000
         BE    MAIN$330              YES                                00480000
         CLI   SRCHNOT,C'\'          \ OPTION IN EFFECT ?               00481000
         BE    MAIN$370              YES, REQUEST FULFILLED             00482000
         MVI   LISTIND,C'N'          OTHERWISE REQUEST NOT SUCCESFULL   00483000
         B     MAIN$370              NEXT STRING                        00484000
MAIN$330 EQU   *                                                        00485000
         CLI   SRCHNOT,C'\'          \ OPTION IN EFFECT ?               00486000
         BNE   MAIN$370              NO, REQUEST FULFILLED              00487000
         MVI   LISTIND,C'N'          OTHERWISE REQUEST NOT SUCCESFULL   00488000
*        *-----------------------------------------------------------*  00489000
*        * CHECK NEXT STRING IN CURRENT SRCHTAB LIST                 *  00490000
*        *-----------------------------------------------------------*  00491000
MAIN$370 EQU   *                                                        00492000
         XR    R1,R1                 PUT LENGTH OF STRING INTO R1       00493000
         IC    R1,SRCHWLEN                                              00494000
         AR    R10,R1                ADD IT TO R10                      00495000
         LA    R10,STL(,R10)         NEXT SRCHTAB ENTRY                 00496000
         B     MAIN$310              GO, CHECK THIS ENTRY               00497000
*        *-----------------------------------------------------------*  00498000
*        * INITIALIZE NEW KEY                                        *  00499000
*        * RESET INDICATION 'FOUND' FOR EACH SRCHTAB ENTRY           *  00500000
*        *-----------------------------------------------------------*  00501000
MAIN$380 EQU   *                                                        00502000
         CLI   SRCHEOF,C'Y'          IS IT EOF ALREADY ?                00503000
         BE    MAIN$900              YES, FINISH                        00504000
         MVC   KEYOLD(IKL),KEY       MOVE KEY TO KEYOLD                 00505000
         MVC   COUNT,=H'0'           ZERO STRING COUNT                  00506000
         L     R10,SRCHLBUF          LOAD ADDRESS OF SEARCH BUFFER      00507000
MAIN$390 EQU   *                                                        00508000
         CLI   SRCHLIST,X'00'        LAST SRCHTAB ENTRY ?               00509000
         BE    MAIN$400              YES, BRANCH                        00510000
         MVI   SRCHFND,C'N'          RESET SRCHTAB INDICATORS           00511000
         XR    R1,R1                 PUT LENGTH OF STRING INTO R1       00512000
         IC    R1,SRCHWLEN                                              00513000
         AR    R10,R1                ADD IT TO R10                      00514000
         LA    R10,STL(,R10)         NEXT SRCHTAB ENTRY                 00515000
         B     MAIN$390              CHECK NEXT SRCHTAB ENTRY           00516000
*        *-----------------------------------------------------------*  00517000
*        *                                                           *  00518000
*        *    SEARCH IN CURRENT RECORD FOR ALL STRINGS OF ALL LISTS  *  00519000
*        *                                                           *  00520000
*        *-----------------------------------------------------------*  00521000
MAIN$400 EQU   *                                                        00522000
         CLC   COUNT(2),WCOUNT       ALL STRINGS ALREADY FOUND ?        00523000
         BE    MAIN$300              YES, READ NEXT RECORD              00524000
         L     R10,SRCHLBUF          LOAD ADDRESS OF SEARCH BUFFER      00525000
MAIN$410 EQU   *                                                        00526000
*        *-----------------------------------------------------------*  00527000
*        *    NEXT ENTRY IN SRCHTAB                                  *  00528000
*        *-----------------------------------------------------------*  00529000
         CLI   SRCHLIST,X'00'        END OF SRCHTAB ?                   00530000
         BE    MAIN$300              YES, READ NEXT RECORD              00531000
         CLI   SRCHFND,C'Y'          STRING ALREADY FOUND ?             00532000
         BE    MAIN$480              YES, PREPARE NEXT ENTRY            00533000
         XR    R7,R7                 CLEAR R7                           00534000
         IC    R7,SRCHWLEN           AND LOAD CURRENT STRING LENGTH     00535000
         LR    R9,R7                 PREPARE R9                         00536000
         BCTR  R9,0                  STRING LENGTH - 1                  00537000
         CH    R7,LRECL              CHECK LENGTHS                      00538000
         BH    MAIN$480              LRECL SMALLER THAN STRINGLENGTH    00539000
         LNR   R7,R7                 OBTAIN STRINGLENGTH NEGATIVE       00540000
         AH    R7,LRECL              R7 = LRECL - STRINGLENGTH          00541000
         LA    R7,1(,R7)                  + 1                           00542000
         L     R8,SRCHBUF            ADDRESS OF RECORD                  00543000
         LA    R8,IKL(,R8)           POINT BEYOND THE KEY               00544000
         STC   R9,CLCWORD+1          MODIFY LENGTH FLD IN NEXT INSTR.   00545000
MAIN$420 EQU   *                                                        00546000
*        *-----------------------------------------------------------*  00547000
*        *    COMPARE STRING IN SRCHTAB WITH PART OF CURRENT RECORD  *  00548000
*        *-----------------------------------------------------------*  00549000
CLCWORD  CLC   0(1,R8),SRCHWORD     COMPARE STRING WITH PART OF RECORD  00550000
         BNE   MAIN$430              NOT EQUAL; BRANCH                  00551000
*        *-----------------------------------------------------------*  00552000
*        *    STRING IS FOUND IN THE CURRENT RECORD;                 *  00553000
*        *         IF NEEDED COMPARE WITH RELATED VALUE              *  00554000
*        *-----------------------------------------------------------*  00555000
         CLI   SRCHVCMP,X'40'        IF NO COMPARE NEEDED               00556000
         BE    MAIN$428                 SKIP COMPARE                    00557000
         XR    R5,R5                 CLEAR R5                           00558000
         IC    R5,SRCHVLEN           LOAD VALUE LENGTH                  00559000
         BCTR  R5,0                  DECREASE BY 1                      00560000
         STC   R5,CLCVALUE+1         MODIFY LENGTH IN INSTRUCTION       00561000
         XR    R5,R5                 CLEAR R5                           00562000
         ICM   R5,7,SRCHVADD         LOAD ADDRESS OF COMPARE VALUE      00563000
         LR    R14,R8               POINT TO START OF STRING IN RECORD  00564000
         AR    R14,R9                POINT TO LAST BYTE OF STRING       00565000
CLCVALUE CLC   1(1,R14),0(R5)        COMPARE STRING WITH RECORDVALUE    00566000
         BE    MAIN$430                 NOT < AND NOT >; SKIP           00567000
         BL    MAIN$422                 IF VALUE LESS THEN SKIP         00568000
*                                    RECORDVALUE > VALUE                00569000
         CLI   SRCHVCMP,C'>'         CHECK COMPARE REQUEST              00570000
         BNE   MAIN$430                 NO MATCH                        00571000
         B     MAIN$428                 MATCH                           00572000
MAIN$422 EQU   *                     RECORDVALUE < VALUE                00573000
         CLI   SRCHVCMP,C'<'         CHECK COMPARE REQUEST              00574000
         BNE   MAIN$430                 NO MATCH                        00575000
MAIN$428 EQU   *                        MATCH                           00576000
         LH    R5,COUNT              ADD 1 TO NR OF STRINGS FOUND       00577000
         LA    R5,1(,R5)                                                00578000
         STH   R5,COUNT              AND STORE NEW VALUE                00579000
         MVI   SRCHFND,C'Y'          INDICATE THIS STRING FOUND         00580000
         B     MAIN$480                                                 00581000
*        *-----------------------------------------------------------*  00582000
*        *    PREPARE NEXT PART OF RECORD TO BE COMPARED WITH        *  00583000
*        *-----------------------------------------------------------*  00584000
MAIN$430 EQU   *                                                        00585000
         LA    R8,1(,R8)             NEXT PART OF RECORD                00586000
         BCT   R7,MAIN$420                                              00587000
*        *-----------------------------------------------------------*  00588000
*        *    PREPARE NEXT SRCHTAB ENTRY                             *  00589000
*        *-----------------------------------------------------------*  00590000
MAIN$480 EQU   *                                                        00591000
         XR    R1,R1                 PUT LENGTH OF STRING INTO R1       00592000
         IC    R1,SRCHWLEN                                              00593000
         AR    R10,R1                ADD IT TO R10                      00594000
         LA    R10,STL(,R10)         NEXT SRCHTAB ENTRY                 00595000
         B     MAIN$410              CHECK NEXT SRCHTAB ENTRY           00596000
*        *-----------------------------------------------------------*  00597000
*        * END OF FILE REACHED ==> PROCESS LAST KEY IN THE FILE      *  00598000
*        *-----------------------------------------------------------*  00599000
MAIN$800 EQU   *                                                        00600000
         MVI   SRCHEOF,C'Y'                                             00601000
         B     MAIN$307                                                 00602000
*        *-----------------------------------------------------------*  00603000
*        * WRITE LAST RECORD IF NEEDED AND CLOSE FILES               *  00604000
*        *-----------------------------------------------------------*  00605000
MAIN$900 EQU   *                                                        00606000
         CH    R11,=H'0'                                                00607000
         BNH   MAIN$910                                                 00608000
         MH    R11,KEYLEN            CALCULATE ACTUAL RECORD LENGTH     00609000
         ST    R11,FINDWLEN                                             00610000
         FSWRITE FSCB=FINDFILE,FORM=E,RECNO=0                           00611000
         LTR   R15,R15               TEST RETURNCODE                    00612000
         BZ    MAIN$905               0 IS OKAY                         00613000
******** FINDTEXT RC 21 : FSWRITE RC <> 0                               00614000
         LA    R15,21                                                   00615000
         B     MAIN$999                                                 00616000
MAIN$905 EQU   *                                                        00617000
         MVI   SWWRITE,C'Y'          INDICATE RECORD HAS BEEN WRITTEN   00618000
MAIN$910 EQU   *                                                        00619000
         FSCLOSE FSCB=SRCHFILE                                          00620000
         LTR   R15,R15               TEST RETURNCODE                    00621000
         BZ    MAIN$911               0 IS OKAY                         00622000
******** FINDTEXT RC 22 : FSCLOSE RC <> 0                               00623000
         LA    R15,22                                                   00624000
         B     MAIN$999                                                 00625000
MAIN$911 EQU   *                                                        00626000
         FSCLOSE FSCB=FINDFILE                                          00627000
         LTR   R15,R15               TEST RETURNCODE                    00628000
         BZ    MAIN$912               0 IS OKAY                         00629000
         CH    R15,=H'6'                                                00630000
         BE    MAIN$912               6 IS OKAY                         00631000
******** FINDTEXT RC 23 : FSCLOSE RC <> 0 | 6                           00632000
         LA    R15,23                                                   00633000
         B     MAIN$999                                                 00634000
MAIN$912 EQU   *                                                        00635000
*--------------------------------------------------------------------*  00636000
*        FREE 256 BYTES STORAGE FOR STACK INPUT                      *  00637000
*--------------------------------------------------------------------*  00638000
         XR    R1,R1                 CLEAR R1                           00639000
         ICM   R1,7,STCKBUF          LOAD ADDRESS OF STORAGE AREA       00640000
         DMSFRET DWORDS=32,LOC=(1),TYPCALL=SVC                          00641000
         LTR   R15,R15                                                  00642000
         BZ    MAIN$920                                                 00643000
******** FINDTEXT RC 24 : DMSFRET RC <> 0                               00644000
         LA    R15,24                                                   00645000
         B     MAIN$999                                                 00646000
MAIN$920 EQU   *                                                        00647000
*--------------------------------------------------------------------*  00648000
*        FREE 2K STORAGE FOR SEARCHLIST TABLE                        *  00649000
*--------------------------------------------------------------------*  00650000
         L     R1,SRCHLBUF           LOAD ADDRESS OF STORAGE AREA       00651000
         DMSFRET DWORDS=256,LOC=(1),TYPCALL=SVC                         00652000
         LTR   R15,R15                                                  00653000
         BZ    MAIN$925                                                 00654000
******** FINDTEXT RC 25 : DMSFRET RC <> 0                               00655000
         LA    R15,25                                                   00656000
         B     MAIN$999                                                 00657000
MAIN$925 EQU   *                                                        00658000
*--------------------------------------------------------------------*  00659000
*        FREE 2K STORAGE FOR COMPARE-VALUE TABLE                     *  00660000
*--------------------------------------------------------------------*  00661000
         L     R1,VALBUF             LOAD ADDRESS OF STORAGE AREA       00662000
         DMSFRET DWORDS=256,LOC=(1),TYPCALL=SVC                         00663000
         LTR   R15,R15                                                  00664000
         BZ    MAIN$930                                                 00665000
******** FINDTEXT RC 26 : DMSFRET RC <> 0                               00666000
         LA    R15,26                                                   00667000
         B     MAIN$999                                                 00668000
MAIN$930 EQU   *                                                        00669000
*--------------------------------------------------------------------*  00670000
*        FREE 256 BYTES STORAGE FOR RECORDBUFFER OF SRCHFILE         *  00671000
*--------------------------------------------------------------------*  00672000
         L     R1,SRCHBUF            LOAD ADDRESS OF STORAGE AREA       00673000
         DMSFRET DWORDS=32,LOC=(1),TYPCALL=SVC                          00674000
         LTR   R15,R15                                                  00675000
         BZ    MAIN$935                                                 00676000
******** FINDTEXT RC 27 : DMSFRET RC <> 0                               00677000
         LA    R15,27                                                   00678000
         B     MAIN$999                                                 00679000
MAIN$935 EQU   *                                                        00680000
*--------------------------------------------------------------------*  00681000
*        FREE 4K STORAGE FOR RECORDBUFFER OF FINDFILE                *  00682000
*--------------------------------------------------------------------*  00683000
         L     R1,FINDBUF            LOAD ADDRESS OF STORAGE AREA       00684000
         DMSFRET DWORDS=512,LOC=(1),TYPCALL=SVC                         00685000
         LTR   R15,R15                                                  00686000
         BZ    MAIN$940                                                 00687000
******** FINDTEXT RC 28 : DMSFRET RC <> 0                               00688000
         LA    R15,28                                                   00689000
         B     MAIN$999                                                 00690000
MAIN$940 EQU   *                                                        00691000
*--------------------------------------------------------------------*  00692000
*        OBEY LINKAGE CONVENTIONS                                    *  00693000
*--------------------------------------------------------------------*  00694000
******** FINDTEXT RC 0  : NORMAL END - OUTPUT FILE WRITTEN              00695000
         LA    R15,0                 SET RETURNCODE ZERO                00696000
         CLI   SWWRITE,C'Y'          OUTPUT FILE WRITTEN ?              00697000
         BE    MAIN$999              YES; SKIP                          00698000
******** FINDTEXT RC 1  : NORMAL END - NO OUTPUT FILE WRITTEN           00699000
         LA    R15,1                 NO FILE WRITTEN; RC := 1           00700000
MAIN$999 EQU   *                     LABEL USED WHEN ERRORS OCCURRED    00701000
         L     R13,4(R13)            RESTORE PTR TO CALLERS SAVEAREA    00702000
         ST    R15,16(,R13)          STORE R15 IN CALLERS SAVEAREA      00703000
         LM    R14,R12,12(R13)       RELOAD CALLERS REGS                00704000
         BR    R14                   END OF JOB                         00705000
*--------------------------------------------------------------------*  00706000
*        FILE DESCRIPTIONS                                           *  00707000
*--------------------------------------------------------------------*  00708000
SRCHFILE FSCB  RECFM=V,FORM=E,RECNO=0,NOREC=1                           00709000
         ORG   SRCHFILE                                                 00710000
         DS    CL8    COMMAND                                           00711000
         DS    CL18   FILEID (FN,FT,FM)                                 00712000
         DS    H      RELATIVE RECORD NUMBER                            00713000
SRCHBUF  DS    A      ADDRESS OF RECORD                                 00714000
         ORG                                                            00715000
FINDFILE FSCB  RECFM=V,FORM=E,RECNO=0,NOREC=1                           00716000
         ORG   FINDFILE                                                 00717000
         DS    CL8    COMMAND                                           00718000
         DS    CL18   FILEID (FN,FT,FM)                                 00719000
         DS    H      RELATIVE RECORD NUMBER                            00720000
FINDBUF  DS    A      ADDRESS OF RECORD                                 00721000
FINDWLEN DS    F      LENGTH OF RECORD                                  00722000
         ORG                                                            00723000
*--------------------------------------------------------------------*  00724000
*        WORK AREAS                                                  *  00725000
*--------------------------------------------------------------------*  00726000
*        SAVEAREA REGISTERS                                             00727000
SAVEAREA DS    18F                   REG SAVE AREA                      00728000
*        PARAMETERLIST                                                  00729000
SENTRIES DS    0D                    PARAMETER LIST FOR SVC 202         00730000
         DC    CL8'SENTRIES'         CMS FUNCTION SENTRIES              00731000
         DC    8X'FF'                                                   00732000
*        PARAMETERLIST                                                  00733000
WAITRD   DS    0D                    PARAMETER LIST FOR SVC 202         00734000
         DC    CL8'WAITRD'           CMS FUNCTION WAITRD                00735000
         DC    AL1(1)                                                   00736000
STCKBUF  DC    AL3(0)                ADDRESS OF INPUT BUFFER            00737000
         DC    C'W'                  FUNCTION FOR STACK READ            00738000
         DC    X'00'                 NO PROMPTING                       00739000
STCKLEN  DC    AL2(255)              LENGTH OF BUFFER                   00740000
         DC    8X'FF'                                                   00741000
*        WORK AREAS REQUIRING ALIGNMENT                                 00742000
         DS    0D                                                       00743000
PRECKEYS DC    8X'00'                PACKED WORK-AREA                   00744000
SRCHLBUF DS    AL4                   ADDRESS SEARCH TABLE               00745000
VALBUF   DS    AL4                   ADDRESS COMPARE-VALUE TABLE        00746000
CVALBUF  DS    AL4                   ADDRESS COMPARE-VALUE IN TABLE     00747000
CFINDBUF DS    AL4                   ADDRESS FINDFILE KEYS IN RECORD    00748000
LRECL    DS    H                     RECORD LENGTH MINUS KEY LENGTH     00749000
WCOUNT   DS    H                     TOTAL NUMBER OF STRINGS IN LISTS   00750000
COUNT    DS    H                                                        00751000
KEYLEN   DC    Y(IKL)                INPUT KEY LENGTH                   00752000
RECLEN   DC    Y(IRL)                INPUT RECORD LENGTH                00753000
OMK      DC    Y(ORL/IKL)            MAXIMUM NR. OF KEYS PER OUTPUTREC  00754000
RECKEYS  DC    H'0'                  ACTUAL NR. KEYS PER FINDFILE REC.  00755000
STCKBUFL DC    H'255'                LENGTH OF STACK BUFFER             00756000
*        WORK AREAS WITHOUT ALIGNMENT                                   00757000
SWWRITE  DC    CL1'N'                INDICATES WHETHER RECORD WRITTEN   00758000
SWNOT    DS    CL1                   DEFINES NOT-RELATIONSHIP (\)       00759000
SWCMP    DS    CL1                   INDICATES USAGE OF < OR >          00760000
KEY      DC    (IKL)X'40'            KEY                                00761000
KEYOLD   DC    (IKL)X'40'            OLD KEY                            00762000
KEYBLANK DC    (IKL)X'40'            TO COMPARE WITH                    00763000
BLANK005 DC    5X'40'                TO COMPARE WITH 5 BLANKS           00764000
FIRSTIME DC    CL1'Y'                INDICATOR FIRST TIME               00765000
LISTIND  DC    CL1'N'                YES IF ALL STRINGS IN LIST MATCH   00766000
SRCHEOF  DC    CL1'N'                END OF FILE STATUS                 00767000
OLDLIST  DC    X'00'                 LIST NUMBER OF OLD LIST            00768000
*--------------------------------------------------------------------*  00769000
*        TRANSLATE TABLE TO TRANSLATE FROM LOWERCASE TO UPPERCASE    *  00770000
*--------------------------------------------------------------------*  00771000
TRANTAB  DS    0D                                                       00772000
         DC    X'000102030405060708090A0B0C0D0E0F'                      00773000
         DC    X'101112131415161718191A1B1C1D1E1F'                      00774000
         DC    X'202122232425262728292A2B2C2D2E2F'                      00775000
         DC    X'303132333435363738393A3B3C3D3E3F'                      00776000
         DC    X'404142434445464748494A4B4C4D4E4F'                      00777000
         DC    X'505152535455565758595A5B5C5D5E5F'                      00778000
         DC    X'606162636465666768696A6B6C6D6E6F'                      00779000
         DC    X'707172737475767778797A7B7C7D7E7F'                      00780000
         DC    X'80C1C2C3C4C5C6C7C8C98A8B8C8D8E8F'                      00781000
         DC    X'90D1D2D3D4D5D6D7D8D99A9B9C9D9E9F'                      00782000
         DC    X'A0A1E2E3E4E5E6E7E8E9AAABACADAEAF'                      00783000
         DC    X'B0B1B2B3B4B5B6B7B8B9BABBBCBDBEBF'                      00784000
         DC    X'C0C1C2C3C4C5C6C7C8C9CACBCCCDCECF'                      00785000
         DC    X'D0D1D2D3D4D5D6D7D8D9DADBDCDDDEDF'                      00786000
         DC    X'E0E1E2E3E4E5E6E7E8E9EAEBECEDEEEF'                      00787000
         DC    X'F0F1F2F3F4F5F6F7F8F9FAFBFCFDFEFF'                      00788000
*--------------------------------------------------------------------*  00789000
*        LITERAL POOL                                                *  00790000
*--------------------------------------------------------------------*  00791000
         LTORG                                                          00792000
*--------------------------------------------------------------------*  00793000
*        DSECT ENTRIES                                               *  00794000
*--------------------------------------------------------------------*  00795000
*        *-----------------------------------------------------------*  00796000
*        * SEARCH TABLE                                              *  00797000
*        *-----------------------------------------------------------*  00798000
SRCHTAB  DSECT                                                          00799000
SRCHLIST DS    X                     OR-RALATED LIST-NUMBER (0=END)     00800000
SRCHFND  DS    C                     INDICATE IF STRING ALREADY FOUND   00801000
SRCHNOT  DS    C                     INDICATE \ CONDITION               00802000
SRCHVCMP DS    C                     COMPARE WITH VALUE (> OR <)        00803000
SRCHVADD DS    3X                    ADDRESS OF VALUE TO BE COMPARED    00804000
SRCHVLEN DS    X                     LENGTH OF VALOUE TO BE COMPARED    00805000
SRCHWLEN DS    X                                                        00806000
SRCHWORD DS    0C                                                       00807000
*        *-----------------------------------------------------------*  00808000
*        * EQUATE LENGTH OF SRCHTAB PREFIX AREA                      *  00809000
*        *-----------------------------------------------------------*  00810000
STL      EQU   SRCHWORD-SRCHTAB                                         00811000
         END                                                            00812000
